/*
 * @Overview 공장 작업장 등록 페이지
 * @History 2024-03-22 / 이원기 / 최초작성

 */

class Tb_factory_class {
  constructor(container) {
    this.ajaxUrl = "./factory.ajax.php";
    this.tbList = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList() {
    let talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);

    ajax_json({
      url: this.ajaxUrl,
      data: { mode: "getFactoryList" },
      success: (data) => {
        if(data.code) {
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
        this.setFilter();
      },
    });

    return true;
  }
  /*
   * @Overview 데이터 필터 함수
   * @Parameter 없음
   * @function 공장, 작업장, 사용 여부 필터링
   */
  setFilter() {
    this.tbList.setFilter((data)=>{
      return(
        true
        // 아이디 명 등 바꾸기 작업장 필터링 없음 만들어야 될 것 같음.
        && ( !document.getElementById("S_USE_FLG")  || ( !document.getElementById("S_USE_FLG").checked || data.USE_FLG === 'Y' ))
        && ( !document.getElementById("S_PLANT_NM") || ( (data.PLANT_CD+"|"+data.PLANT_NM).search(document.getElementById("S_PLANT_NM").value) !== -1 ) )
      )
    })
  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I" });
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getSelectedRows(); // 선택된 모든 행 가져오기

    // 선택된 각 행 삭제
    selectedRows.forEach((row) => {
      // STAUS D로 바꾸기
      row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";

      const rowElement = row.getElement();
      rowElement.classList.add("remove-row");
    });
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
    } else {
      this.tbList.deselectRow();
      tgt.select();
      Tb_workPlace.getMainList(tgt.getData().FT_CD);
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    var editor = tgt.getColumn().getDefinition().editor;
    
    switch (tgt.getField()) {
      case "USE_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        break;
      case "사업장명":
        popFacility({
          tgt_id: "사업장 코드",
          tgt_name: "사업장명",
        },tgt.getRow());

        break;
      // case "ZIP_CD":
      //   popFacility({
      //     tgt_id: "사업장 코드",
      //     tgt_name: "사업장명",
      //   },tgt.getRow());

      //   break;
      default:
        if (!editor) {
          this.rowClick && this.rowClick(e, tgt.getRow());
        }
        break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

  /*
   * @Overview 추가, 수정 및 삭제 데이터 저장
   * @Parameter 없음
   * @Function 기본키 중복 확인
   * @Function _STATUS_ U, I, D인 데이터베이스 가져와서 처리.
   */
  putData() {
    // 기본키 중복 확인 및 방지
    // _STATUS_ 있는 데이터만 들고와서 PUT하기
  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    // field 정의
    const fields = [
      { field: "rownum", title: "NO", width: 50 },
      { field: "공장 코드", title: "공장 코드", width: 150, 
        editor: tb_custom_editor.pkCode, 
        editorParams: {format:"number"},
        formatter: tb_custom_formatter.pkCode
      },
      { field: "공장명", title: "공장명", width: 150, editor:"input", cssClass:"editable-cell" },
      { field: "ZIP_CD", title: "공장 우편번호", width: 300, editor:tb_custom_editor.zip, cssClass:"btnFindAddr editable-cell", },
      { field: "공장 주소", title: "공장 주소", width: 400, editor:"input", cssClass:"editable-cell" },
      { field: "사업장명", title: "사업장명", width: 150, editor:"input", cssClass:"editable-cell" },
      { field: "REMK", title: "비고", width: 300, editor:"input", cssClass:"editable-cell" },
      { field: "USE_FLG", title: "사용", width: 50, cssClass:"editable-cell", formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: {checkval:'Y'} },
    ];
    const commonFieldData = {
      headerSort: false,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
    });

    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      // this.getMainList();
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e,tgt) => {
      this.cellClick && this.cellClick(e,tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector("#filter_btn");
      filterBtn.addEventListener(evt, () => {
        // setFilter 또는 setData
        this.setFilter && this.setFilter();
      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector("#put_btn");
      putBtn.addEventListener(evt, () => {
        this.putData && this.putData();
      });
    });
  }
}

class Tb_workPlace_class {
  constructor(container) {
    this.ajaxUrl = "./factory.ajax.php";
    this.tbList = "";
    this.code = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList(code) {
    this.code = code;
    let talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);

    ajax_json({
      url: this.ajaxUrl,
      data: { mode: "getPlantList", FT_CD: code },
      success: (data) => {
        if(data.code) {
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
        this.setFilter();
      },
    });
    return true;
  }
  /*
   * @Overview 데이터 필터 함수
   * @Parameter 없음
   * @function 필터링 없음.
   */
  setFilter() {
  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I", FT_CD: this.code, USE_FLG: "Y" });
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getSelectedRows(); // 선택된 모든 행 가져오기

    // 선택된 각 행 삭제
    selectedRows.forEach((row) => {
      // STAUS D로 바꾸기
      row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";

      const rowElement = row.getElement();
      rowElement.classList.add("remove-row");
    });
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
    } else {
      tgt.select();
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    var editor = tgt.getColumn().getDefinition().editor;
    
    switch (tgt.getField()) {
      case "USE_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        break;
      default:
        if (!editor) {
          this.rowClick && this.rowClick(e, tgt.getRow());
        }
        break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

  /*
   * @Overview 추가, 수정 및 삭제 데이터 저장
   * @Parameter 없음
   * @Function 기본키 중복 확인
   * @Function _STATUS_ U, I, D인 데이터베이스 가져와서 처리.
   */
  putData() {
    // 기본키 중복 확인 및 방지
    // _STATUS_ 있는 데이터만 들고와서 PUT하기
  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    // field 정의
    const fields = [
      { field: "rownum", title: "NO", width: 50 },
      { field: "PLANT_CD", title: "작업장 코드", width: 150, editor:"input", editable: (cell) => {
        const val = cell.getData();
        return val._STATUS_ === "I";
      },},
      { field: "PLANT_NM", title: "작업장명", width: 150, editor:"input" },
      { field: "USE_FLG", title: "사용", width: 50, cssClass:"editable-cell", formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: {checkval:'Y'} },
    ];
    const commonFieldData = {
      headerSort: false,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
    });


    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      // this.getMainList();
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e,tgt) => {
      this.cellClick && this.cellClick(e,tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
  }
}





const Tb_factory = new Tb_factory_class("#main_table");
Tb_factory.init();
const Tb_workPlace = new Tb_workPlace_class("#sub_table");
Tb_workPlace.init();
